/*----- PROTECTED REGION ID(BacnetConf.h) ENABLED START -----*/
/* clang-format on */
//=============================================================================
//
// file :        BacnetConf.h
//
// description : Include file for the BacnetConf class
//
// project :     BacnetConf
//
// This file is part of Tango device class.
//
// Tango is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// Tango is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with Tango.  If not, see <http://www.gnu.org/licenses/>.
//
//
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================


#ifndef BacnetConf_H
#define BacnetConf_H

#include <tango/tango.h>
//#include <unordered_map>
#include "readthread.h"


/* clang-format off */
/*----- PROTECTED REGION END -----*/	//	BacnetConf.h

#ifdef TANGO_LOG
	// cppTango after c934adea (Merge branch 'remove-cout-definition' into 'main', 2022-05-23)
	// nothing to do
#else
	// cppTango 9.3-backports and older
	#define TANGO_LOG       cout
	#define TANGO_LOG_INFO  cout2
	#define TANGO_LOG_DEBUG cout3
#endif // TANGO_LOG

/**
 *  BacnetConf class description:
 *    Bacnet configurable device server
 */


namespace BacnetConf_ns
{
/*----- PROTECTED REGION ID(BacnetConf::Additional Class Declarations) ENABLED START -----*/
/* clang-format on */
//	Additional Class Declarations
constexpr char const* BAC_FLOAT="FLOAT";
constexpr char const* BAC_DOUBLE="DOUBLE";
constexpr char const* BAC_INT32="INT32";
constexpr char const* BAC_UINT32="UINT32";
constexpr char const* BAC_INT16="INT16";
constexpr char const* BAC_BYTE="BYTE";
constexpr char const* BAC_BOOL="BOOL";
constexpr unsigned int BAC_MAX_SIZE=128;//TODO

enum class data_type_t
{
	BAC_Real,
	BAC_Unsigned_Int,
	BAC_Enumerated,
	BAC_Boolean
};

struct attr_desc_t
{
	std::string name;
	std::string type;
	struct timeval last_read;
	unsigned int size;

	Tango::DevFloat value_f;//[BAC_MAX_SIZE];
	Tango::DevDouble value_d;//[BAC_MAX_SIZE];
	Tango::DevLong value_l;//[BAC_MAX_SIZE];
	Tango::DevShort value_s;//[BAC_MAX_SIZE];
	Tango::DevUChar value_uc;//[BAC_MAX_SIZE];
	Tango::DevBoolean value_b;//[BAC_MAX_SIZE];
	std::string s_device_instance;//e.g. 2107393
	uint32_t device_instance;
	std::string s_object_type; //e.g. analog-input, analog-output
	uint32_t object_type;
	std::string s_object_instance; //e.g. 49
	uint32_t object_instance;
	std::string s_property; //e.g. present-value
	uint32_t property;
	int32_t property_index;
	std::string s_object_name; //e.g. "B'BK12e3e4'BK3'DmpOa"
};
typedef std::map<std::string,attr_desc_t> attr_map_t;

struct object_t
{
	std::string s_object_type; //e.g. analog-input, analog-output
	uint32_t object_type;
	std::string s_object_instance; //e.g. 49
	uint32_t object_instance;
	std::string s_property; //e.g. present-value
	uint32_t property;
	int32_t property_index;
	std::string s_object_name; //e.g. "B'BK12e3e4'BK3'DmpOa"
	data_type_t data_type;
};
typedef std::map<std::string,vector<object_t> > dev_map_t;

struct name_t
{
	std::string s_device_instance; //e.g. 2127874
	std::string s_object_type; //e.g. analog-input, analog-output
	std::string s_object_instance; //e.g. 49
	std::string s_object_name; //e.g. "B'BK12e3e4'BK3'DmpOa"
	std::string s_property; //e.g. present-value
};
typedef std::map<std::string,name_t > name_map_t;
/* clang-format off */
/*----- PROTECTED REGION END -----*/	//	BacnetConf::Additional Class Declarations

class BacnetConf : public TANGO_BASE_CLASS
{

/*----- PROTECTED REGION ID(BacnetConf::Data Members) ENABLED START -----*/
/* clang-format on */
//	Add your own data members
std::map<std::string,data_type_t> map_data_type = {
	{"Real",data_type_t::BAC_Real},
	{"Unsigned Int",data_type_t::BAC_Unsigned_Int},
	{"Enumerated",data_type_t::BAC_Enumerated},
	{"Boolean",data_type_t::BAC_Boolean}
};
	readthread *loop;
public:
	bool created_attr;
	attr_map_t attr_map;
	name_map_t name_obj_map;
	dev_map_t dev_name_map;
/* clang-format off */
/*----- PROTECTED REGION END -----*/	//	BacnetConf::Data Members

//	Device property data members
public:
	//	Attr_config_prop:	
	std::vector<std::string>	attr_config_prop;
	//	Attr_config_file:	
	std::string	attr_config_file;
	//	BACNET_BBMD_ADDRESS:	BBMD_ADDRESS IP address
	std::string	bACNET_BBMD_ADDRESS;
	//	BACNET_IP_PORT:	47808 (BAC0) or 47809 (BAC1)
	Tango::DevUShort	bACNET_IP_PORT;
	//	BACNET_BBMD_PORT:	47808 (BAC0) or 47809 (BAC1)
	Tango::DevUShort	bACNET_BBMD_PORT;
	//	PollingPeriod:	Polling Period in seconds
	Tango::DevLong	pollingPeriod;
	//	Name_Map_File:	Filename where device-id, object-identifier, object-name map is stored
	std::string	name_Map_File;
	//	MaxReadPropertyMultiple:	Maximum object to be read in a single ReadPropertyMultiple
	Tango::DevShort	maxReadPropertyMultiple;


//	Constructors and destructors
public:
	/**
	 * Constructs a newly device object.
	 *
	 *	@param cl	Class.
	 *	@param s 	Device Name
	 */
	BacnetConf(Tango::DeviceClass *cl,std::string &s);
	/**
	 * Constructs a newly device object.
	 *
	 *	@param cl	Class.
	 *	@param s 	Device Name
	 */
	BacnetConf(Tango::DeviceClass *cl,const char *s);
	/**
	 * Constructs a newly device object.
	 *
	 *	@param cl	Class.
	 *	@param s 	Device name
	 *	@param d	Device description.
	 */
	BacnetConf(Tango::DeviceClass *cl,const char *s,const char *d);
	/**
	 * The device object destructor.
	 */
	~BacnetConf();


//	Miscellaneous methods
public:
	/*
	 *	will be called at device destruction or at init command.
	 */
	void delete_device();
	/*
	 *	Initialize the device
	 */
	virtual void init_device();
	/*
	 *	Read the device properties from database
	 */
	void get_device_property();
	/*
	 *	Always executed method before execution command method.
	 */
	virtual void always_executed_hook();


//	Attribute methods
public:
	//--------------------------------------------------------
	/*
	 *	Method      : BacnetConf::read_attr_hardware()
	 * Description:  Hardware acquisition for attributes.
	 */
	//--------------------------------------------------------
	virtual void read_attr_hardware(std::vector<long> &attr_list);

//	Dynamic attribute methods
public:

	/**
	 *	Attribute dynScalarFloatRO related methods
	 *
	 *
	 *	Data type:  Tango::DevFloat
	 *	Attr type:	Scalar
	 */
	virtual void read_dynScalarFloatRO(Tango::Attribute &attr);
	virtual bool is_dynScalarFloatRO_allowed(Tango::AttReqType type);
	void add_dynScalarFloatRO_dynamic_attribute(std::string attname);
	void remove_dynScalarFloatRO_dynamic_attribute(std::string attname);
	Tango::DevFloat *get_dynScalarFloatRO_data_ptr(std::string &name);
	map<std::string,Tango::DevFloat>	   dynScalarFloatRO_data;

	/**
	 *	Attribute dynScalarInt16RO related methods
	 *
	 *
	 *	Data type:  Tango::DevShort
	 *	Attr type:	Scalar
	 */
	virtual void read_dynScalarInt16RO(Tango::Attribute &attr);
	virtual bool is_dynScalarInt16RO_allowed(Tango::AttReqType type);
	void add_dynScalarInt16RO_dynamic_attribute(std::string attname);
	void remove_dynScalarInt16RO_dynamic_attribute(std::string attname);
	Tango::DevShort *get_dynScalarInt16RO_data_ptr(std::string &name);
	map<std::string,Tango::DevShort>	   dynScalarInt16RO_data;

	/**
	 *	Attribute dynScalarInt32RO related methods
	 *
	 *
	 *	Data type:  Tango::DevLong
	 *	Attr type:	Scalar
	 */
	virtual void read_dynScalarInt32RO(Tango::Attribute &attr);
	virtual bool is_dynScalarInt32RO_allowed(Tango::AttReqType type);
	void add_dynScalarInt32RO_dynamic_attribute(std::string attname);
	void remove_dynScalarInt32RO_dynamic_attribute(std::string attname);
	Tango::DevLong *get_dynScalarInt32RO_data_ptr(std::string &name);
	map<std::string,Tango::DevLong>	   dynScalarInt32RO_data;

	/**
	 *	Attribute dynScalarByteRO related methods
	 *
	 *
	 *	Data type:  Tango::DevUChar
	 *	Attr type:	Scalar
	 */
	virtual void read_dynScalarByteRO(Tango::Attribute &attr);
	virtual bool is_dynScalarByteRO_allowed(Tango::AttReqType type);
	void add_dynScalarByteRO_dynamic_attribute(std::string attname);
	void remove_dynScalarByteRO_dynamic_attribute(std::string attname);
	Tango::DevUChar *get_dynScalarByteRO_data_ptr(std::string &name);
	map<std::string,Tango::DevUChar>	   dynScalarByteRO_data;

	/**
	 *	Attribute dynScalarBoolRO related methods
	 *
	 *
	 *	Data type:  Tango::DevBoolean
	 *	Attr type:	Scalar
	 */
	virtual void read_dynScalarBoolRO(Tango::Attribute &attr);
	virtual bool is_dynScalarBoolRO_allowed(Tango::AttReqType type);
	void add_dynScalarBoolRO_dynamic_attribute(std::string attname);
	void remove_dynScalarBoolRO_dynamic_attribute(std::string attname);
	Tango::DevBoolean *get_dynScalarBoolRO_data_ptr(std::string &name);
	map<std::string,Tango::DevBoolean>	   dynScalarBoolRO_data;

	/**
	 *	Attribute dynScalarDoubleRO related methods
	 *
	 *
	 *	Data type:  Tango::DevDouble
	 *	Attr type:	Scalar
	 */
	virtual void read_dynScalarDoubleRO(Tango::Attribute &attr);
	virtual bool is_dynScalarDoubleRO_allowed(Tango::AttReqType type);
	void add_dynScalarDoubleRO_dynamic_attribute(std::string attname);
	void remove_dynScalarDoubleRO_dynamic_attribute(std::string attname);
	Tango::DevDouble *get_dynScalarDoubleRO_data_ptr(std::string &name);
	map<std::string,Tango::DevDouble>	   dynScalarDoubleRO_data;

	/**
	 *	Attribute dynScalarUInt32RO related methods
	 *
	 *
	 *	Data type:  Tango::DevULong
	 *	Attr type:	Scalar
	 */
	virtual void read_dynScalarUInt32RO(Tango::Attribute &attr);
	virtual bool is_dynScalarUInt32RO_allowed(Tango::AttReqType type);
	void add_dynScalarUInt32RO_dynamic_attribute(std::string attname);
	void remove_dynScalarUInt32RO_dynamic_attribute(std::string attname);
	Tango::DevULong *get_dynScalarUInt32RO_data_ptr(std::string &name);
	map<std::string,Tango::DevULong>	   dynScalarUInt32RO_data;

	//--------------------------------------------------------
	/**
	 *	Method      : BacnetConf::add_dynamic_attributes()
	 * Description:  Add dynamic attributes if any.
	 */
	//--------------------------------------------------------
	void add_dynamic_attributes();




//	Command related methods
public:
	/**
	 *	Command FindName related method
	 * Description:  Looks for object-name in NameMap and return device and object
	 *
	 *	@param argin object-name
	 *	@returns device-id,object-type,object-instance
	 */
	virtual Tango::DevString find_name(Tango::DevString argin);
	virtual bool is_FindName_allowed(const CORBA::Any &any);
	/**
	 *	Command FindObjects related method
	 * Description:  Looks for device-id in NameMap and return list of objects
	 *
	 *	@param argin device-id
	 *	@returns [0]: object-type,object-instance,object-name
	 *	[1]: ...
	 */
	virtual Tango::DevVarStringArray *find_objects(Tango::DevString argin);
	virtual bool is_FindObjects_allowed(const CORBA::Any &any);


	//--------------------------------------------------------
	/**
	 *	Method      : BacnetConf::add_dynamic_commands()
	 * Description:  Add dynamic commands if any.
	 */
	//--------------------------------------------------------
	void add_dynamic_commands();

/*----- PROTECTED REGION ID(BacnetConf::Additional Method prototypes) ENABLED START -----*/
/* clang-format on */
//	Additional Method prototypes
void create_dynamic_attributes(std::vector<std::string> attr_config, bool create_all_objects=false);
/* clang-format off */
/*----- PROTECTED REGION END -----*/	//	BacnetConf::Additional Method prototypes
};

/*----- PROTECTED REGION ID(BacnetConf::Additional Classes Definitions) ENABLED START -----*/
/* clang-format on */
//	Additional Classes Definitions
/* clang-format off */
/*----- PROTECTED REGION END -----*/	//	BacnetConf::Additional Classes Definitions

}	//	End of namespace

#endif   //	BacnetConf_H
