/*----- PROTECTED REGION ID(BacnetConf::DynAttrUtils.cpp) ENABLED START -----*/
/* clang-format on */
//=============================================================================
//
// file :        BacnetConfDynAttrUtils.cpp
//
// description : Dynamic attributes utilities file for the BacnetConf class
//
// project :     BacnetConf
//
// This file is part of Tango device class.
//
// Tango is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// Tango is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with Tango.  If not, see <http://www.gnu.org/licenses/>.
//
//
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================


#include <BacnetConf.h>
#include <BacnetConfClass.h>
/* clang-format off */
/*----- PROTECTED REGION END -----*/	//	BacnetConf::DynAttrUtils.cpp

//================================================================
//  Attributes managed are:
//================================================================
//  dynScalarFloatRO   |  Tango::DevFloat	Scalar
//  dynScalarInt16RO   |  Tango::DevShort	Scalar
//  dynScalarInt32RO   |  Tango::DevLong	Scalar
//  dynScalarByteRO    |  Tango::DevUChar	Scalar
//  dynScalarBoolRO    |  Tango::DevBoolean	Scalar
//  dynScalarDoubleRO  |  Tango::DevDouble	Scalar
//  dynScalarUInt32RO  |  Tango::DevULong	Scalar
//================================================================

//	For compatibility reason, this file (BacnetConfDynAttrUtils)
//	manage also the dynamic command utilities.
//================================================================
//  The following table gives the correspondence
//  between command and method names.
//
//  Command name  |  Method name
//================================================================
//================================================================

namespace BacnetConf_ns
{
//=============================================================
//	Add/Remove dynamic attribute methods
//=============================================================

//--------------------------------------------------------
/**
 *	Add a dynScalarFloatRO dynamic attribute.
 *
 *  parameter attname: attribute name to be created and added.
 */
//--------------------------------------------------------
void BacnetConf::add_dynScalarFloatRO_dynamic_attribute(std::string attname)
{
	//	Attribute : dynScalarFloatRO
	dynScalarFloatROAttrib	*dynscalarfloatro = new dynScalarFloatROAttrib(attname);
	Tango::UserDefaultAttrProp	dynscalarfloatro_prop;
	//	description	not set for dynScalarFloatRO
	//	label	not set for dynScalarFloatRO
	//	unit	not set for dynScalarFloatRO
	//	standard_unit	not set for dynScalarFloatRO
	//	display_unit	not set for dynScalarFloatRO
	//	format	not set for dynScalarFloatRO
	//	max_value	not set for dynScalarFloatRO
	//	min_value	not set for dynScalarFloatRO
	//	max_alarm	not set for dynScalarFloatRO
	//	min_alarm	not set for dynScalarFloatRO
	//	max_warning	not set for dynScalarFloatRO
	//	min_warning	not set for dynScalarFloatRO
	//	delta_t	not set for dynScalarFloatRO
	//	delta_val	not set for dynScalarFloatRO
	/*----- PROTECTED REGION ID(BacnetConf::att_dynScalarFloatRO_dynamic_attribute) ENABLED START -----*/
	/* clang-format on */
	//	Add your own code
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	BacnetConf::att_dynScalarFloatRO_dynamic_attribute
	dynscalarfloatro->set_default_properties(dynscalarfloatro_prop);
	//	Not Polled
	dynscalarfloatro->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	dynScalarFloatRO_data.insert(make_pair(attname, 0.0));
	add_attribute(dynscalarfloatro);
}
//--------------------------------------------------------
/**
 *	remove a dynScalarFloatRO dynamic attribute.
 *
 *  parameter attname: attribute name to be removed.
 */
//--------------------------------------------------------
void BacnetConf::remove_dynScalarFloatRO_dynamic_attribute(std::string attname)
{
	remove_attribute(attname, true, Tango::Util::instance()->_UseDb);
	map<std::string,Tango::DevFloat>::iterator ite;
	if ((ite=dynScalarFloatRO_data.find(attname))!=dynScalarFloatRO_data.end())
	{
		/*----- PROTECTED REGION ID(BacnetConf::remove_dynScalarFloatRO_dynamic_attribute) ENABLED START -----*/
		/* clang-format on */
		//	Add your own code
		/* clang-format off */
		/*----- PROTECTED REGION END -----*/	//	BacnetConf::remove_dynScalarFloatRO_dynamic_attribute
		dynScalarFloatRO_data.erase(ite);
	}
}
//--------------------------------------------------------
/**
 *	Add a dynScalarInt16RO dynamic attribute.
 *
 *  parameter attname: attribute name to be created and added.
 */
//--------------------------------------------------------
void BacnetConf::add_dynScalarInt16RO_dynamic_attribute(std::string attname)
{
	//	Attribute : dynScalarInt16RO
	dynScalarInt16ROAttrib	*dynscalarint16ro = new dynScalarInt16ROAttrib(attname);
	Tango::UserDefaultAttrProp	dynscalarint16ro_prop;
	//	description	not set for dynScalarInt16RO
	//	label	not set for dynScalarInt16RO
	//	unit	not set for dynScalarInt16RO
	//	standard_unit	not set for dynScalarInt16RO
	//	display_unit	not set for dynScalarInt16RO
	//	format	not set for dynScalarInt16RO
	//	max_value	not set for dynScalarInt16RO
	//	min_value	not set for dynScalarInt16RO
	//	max_alarm	not set for dynScalarInt16RO
	//	min_alarm	not set for dynScalarInt16RO
	//	max_warning	not set for dynScalarInt16RO
	//	min_warning	not set for dynScalarInt16RO
	//	delta_t	not set for dynScalarInt16RO
	//	delta_val	not set for dynScalarInt16RO
	/*----- PROTECTED REGION ID(BacnetConf::att_dynScalarInt16RO_dynamic_attribute) ENABLED START -----*/
	/* clang-format on */
	//	Add your own code
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	BacnetConf::att_dynScalarInt16RO_dynamic_attribute
	dynscalarint16ro->set_default_properties(dynscalarint16ro_prop);
	//	Not Polled
	dynscalarint16ro->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	dynScalarInt16RO_data.insert(make_pair(attname, 0));
	add_attribute(dynscalarint16ro);
}
//--------------------------------------------------------
/**
 *	remove a dynScalarInt16RO dynamic attribute.
 *
 *  parameter attname: attribute name to be removed.
 */
//--------------------------------------------------------
void BacnetConf::remove_dynScalarInt16RO_dynamic_attribute(std::string attname)
{
	remove_attribute(attname, true, Tango::Util::instance()->_UseDb);
	map<std::string,Tango::DevShort>::iterator ite;
	if ((ite=dynScalarInt16RO_data.find(attname))!=dynScalarInt16RO_data.end())
	{
		/*----- PROTECTED REGION ID(BacnetConf::remove_dynScalarInt16RO_dynamic_attribute) ENABLED START -----*/
		/* clang-format on */
		//	Add your own code
		/* clang-format off */
		/*----- PROTECTED REGION END -----*/	//	BacnetConf::remove_dynScalarInt16RO_dynamic_attribute
		dynScalarInt16RO_data.erase(ite);
	}
}
//--------------------------------------------------------
/**
 *	Add a dynScalarInt32RO dynamic attribute.
 *
 *  parameter attname: attribute name to be created and added.
 */
//--------------------------------------------------------
void BacnetConf::add_dynScalarInt32RO_dynamic_attribute(std::string attname)
{
	//	Attribute : dynScalarInt32RO
	dynScalarInt32ROAttrib	*dynscalarint32ro = new dynScalarInt32ROAttrib(attname);
	Tango::UserDefaultAttrProp	dynscalarint32ro_prop;
	//	description	not set for dynScalarInt32RO
	//	label	not set for dynScalarInt32RO
	//	unit	not set for dynScalarInt32RO
	//	standard_unit	not set for dynScalarInt32RO
	//	display_unit	not set for dynScalarInt32RO
	//	format	not set for dynScalarInt32RO
	//	max_value	not set for dynScalarInt32RO
	//	min_value	not set for dynScalarInt32RO
	//	max_alarm	not set for dynScalarInt32RO
	//	min_alarm	not set for dynScalarInt32RO
	//	max_warning	not set for dynScalarInt32RO
	//	min_warning	not set for dynScalarInt32RO
	//	delta_t	not set for dynScalarInt32RO
	//	delta_val	not set for dynScalarInt32RO
	/*----- PROTECTED REGION ID(BacnetConf::att_dynScalarInt32RO_dynamic_attribute) ENABLED START -----*/
	/* clang-format on */
	//	Add your own code
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	BacnetConf::att_dynScalarInt32RO_dynamic_attribute
	dynscalarint32ro->set_default_properties(dynscalarint32ro_prop);
	//	Not Polled
	dynscalarint32ro->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	dynScalarInt32RO_data.insert(make_pair(attname, 0));
	add_attribute(dynscalarint32ro);
}
//--------------------------------------------------------
/**
 *	remove a dynScalarInt32RO dynamic attribute.
 *
 *  parameter attname: attribute name to be removed.
 */
//--------------------------------------------------------
void BacnetConf::remove_dynScalarInt32RO_dynamic_attribute(std::string attname)
{
	remove_attribute(attname, true, Tango::Util::instance()->_UseDb);
	map<std::string,Tango::DevLong>::iterator ite;
	if ((ite=dynScalarInt32RO_data.find(attname))!=dynScalarInt32RO_data.end())
	{
		/*----- PROTECTED REGION ID(BacnetConf::remove_dynScalarInt32RO_dynamic_attribute) ENABLED START -----*/
		/* clang-format on */
		//	Add your own code
		/* clang-format off */
		/*----- PROTECTED REGION END -----*/	//	BacnetConf::remove_dynScalarInt32RO_dynamic_attribute
		dynScalarInt32RO_data.erase(ite);
	}
}
//--------------------------------------------------------
/**
 *	Add a dynScalarByteRO dynamic attribute.
 *
 *  parameter attname: attribute name to be created and added.
 */
//--------------------------------------------------------
void BacnetConf::add_dynScalarByteRO_dynamic_attribute(std::string attname)
{
	//	Attribute : dynScalarByteRO
	dynScalarByteROAttrib	*dynscalarbytero = new dynScalarByteROAttrib(attname);
	Tango::UserDefaultAttrProp	dynscalarbytero_prop;
	//	description	not set for dynScalarByteRO
	//	label	not set for dynScalarByteRO
	//	unit	not set for dynScalarByteRO
	//	standard_unit	not set for dynScalarByteRO
	//	display_unit	not set for dynScalarByteRO
	//	format	not set for dynScalarByteRO
	//	max_value	not set for dynScalarByteRO
	//	min_value	not set for dynScalarByteRO
	//	max_alarm	not set for dynScalarByteRO
	//	min_alarm	not set for dynScalarByteRO
	//	max_warning	not set for dynScalarByteRO
	//	min_warning	not set for dynScalarByteRO
	//	delta_t	not set for dynScalarByteRO
	//	delta_val	not set for dynScalarByteRO
	/*----- PROTECTED REGION ID(BacnetConf::att_dynScalarByteRO_dynamic_attribute) ENABLED START -----*/
	/* clang-format on */
	//	Add your own code
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	BacnetConf::att_dynScalarByteRO_dynamic_attribute
	dynscalarbytero->set_default_properties(dynscalarbytero_prop);
	//	Not Polled
	dynscalarbytero->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	dynScalarByteRO_data.insert(make_pair(attname, 0));
	add_attribute(dynscalarbytero);
}
//--------------------------------------------------------
/**
 *	remove a dynScalarByteRO dynamic attribute.
 *
 *  parameter attname: attribute name to be removed.
 */
//--------------------------------------------------------
void BacnetConf::remove_dynScalarByteRO_dynamic_attribute(std::string attname)
{
	remove_attribute(attname, true, Tango::Util::instance()->_UseDb);
	map<std::string,Tango::DevUChar>::iterator ite;
	if ((ite=dynScalarByteRO_data.find(attname))!=dynScalarByteRO_data.end())
	{
		/*----- PROTECTED REGION ID(BacnetConf::remove_dynScalarByteRO_dynamic_attribute) ENABLED START -----*/
		/* clang-format on */
		//	Add your own code
		/* clang-format off */
		/*----- PROTECTED REGION END -----*/	//	BacnetConf::remove_dynScalarByteRO_dynamic_attribute
		dynScalarByteRO_data.erase(ite);
	}
}
//--------------------------------------------------------
/**
 *	Add a dynScalarBoolRO dynamic attribute.
 *
 *  parameter attname: attribute name to be created and added.
 */
//--------------------------------------------------------
void BacnetConf::add_dynScalarBoolRO_dynamic_attribute(std::string attname)
{
	//	Attribute : dynScalarBoolRO
	dynScalarBoolROAttrib	*dynscalarboolro = new dynScalarBoolROAttrib(attname);
	Tango::UserDefaultAttrProp	dynscalarboolro_prop;
	//	description	not set for dynScalarBoolRO
	//	label	not set for dynScalarBoolRO
	//	unit	not set for dynScalarBoolRO
	//	standard_unit	not set for dynScalarBoolRO
	//	display_unit	not set for dynScalarBoolRO
	//	format	not set for dynScalarBoolRO
	//	max_value	not set for dynScalarBoolRO
	//	min_value	not set for dynScalarBoolRO
	//	max_alarm	not set for dynScalarBoolRO
	//	min_alarm	not set for dynScalarBoolRO
	//	max_warning	not set for dynScalarBoolRO
	//	min_warning	not set for dynScalarBoolRO
	//	delta_t	not set for dynScalarBoolRO
	//	delta_val	not set for dynScalarBoolRO
	/*----- PROTECTED REGION ID(BacnetConf::att_dynScalarBoolRO_dynamic_attribute) ENABLED START -----*/
	/* clang-format on */
	//	Add your own code
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	BacnetConf::att_dynScalarBoolRO_dynamic_attribute
	dynscalarboolro->set_default_properties(dynscalarboolro_prop);
	//	Not Polled
	dynscalarboolro->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	dynScalarBoolRO_data.insert(make_pair(attname, false));
	add_attribute(dynscalarboolro);
}
//--------------------------------------------------------
/**
 *	remove a dynScalarBoolRO dynamic attribute.
 *
 *  parameter attname: attribute name to be removed.
 */
//--------------------------------------------------------
void BacnetConf::remove_dynScalarBoolRO_dynamic_attribute(std::string attname)
{
	remove_attribute(attname, true, Tango::Util::instance()->_UseDb);
	map<std::string,Tango::DevBoolean>::iterator ite;
	if ((ite=dynScalarBoolRO_data.find(attname))!=dynScalarBoolRO_data.end())
	{
		/*----- PROTECTED REGION ID(BacnetConf::remove_dynScalarBoolRO_dynamic_attribute) ENABLED START -----*/
		/* clang-format on */
		//	Add your own code
		/* clang-format off */
		/*----- PROTECTED REGION END -----*/	//	BacnetConf::remove_dynScalarBoolRO_dynamic_attribute
		dynScalarBoolRO_data.erase(ite);
	}
}
//--------------------------------------------------------
/**
 *	Add a dynScalarDoubleRO dynamic attribute.
 *
 *  parameter attname: attribute name to be created and added.
 */
//--------------------------------------------------------
void BacnetConf::add_dynScalarDoubleRO_dynamic_attribute(std::string attname)
{
	//	Attribute : dynScalarDoubleRO
	dynScalarDoubleROAttrib	*dynscalardoublero = new dynScalarDoubleROAttrib(attname);
	Tango::UserDefaultAttrProp	dynscalardoublero_prop;
	//	description	not set for dynScalarDoubleRO
	//	label	not set for dynScalarDoubleRO
	//	unit	not set for dynScalarDoubleRO
	//	standard_unit	not set for dynScalarDoubleRO
	//	display_unit	not set for dynScalarDoubleRO
	//	format	not set for dynScalarDoubleRO
	//	max_value	not set for dynScalarDoubleRO
	//	min_value	not set for dynScalarDoubleRO
	//	max_alarm	not set for dynScalarDoubleRO
	//	min_alarm	not set for dynScalarDoubleRO
	//	max_warning	not set for dynScalarDoubleRO
	//	min_warning	not set for dynScalarDoubleRO
	//	delta_t	not set for dynScalarDoubleRO
	//	delta_val	not set for dynScalarDoubleRO
	/*----- PROTECTED REGION ID(BacnetConf::att_dynScalarDoubleRO_dynamic_attribute) ENABLED START -----*/
	/* clang-format on */
	//	Add your own code
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	BacnetConf::att_dynScalarDoubleRO_dynamic_attribute
	dynscalardoublero->set_default_properties(dynscalardoublero_prop);
	//	Not Polled
	dynscalardoublero->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	dynScalarDoubleRO_data.insert(make_pair(attname, 0.0));
	add_attribute(dynscalardoublero);
}
//--------------------------------------------------------
/**
 *	remove a dynScalarDoubleRO dynamic attribute.
 *
 *  parameter attname: attribute name to be removed.
 */
//--------------------------------------------------------
void BacnetConf::remove_dynScalarDoubleRO_dynamic_attribute(std::string attname)
{
	remove_attribute(attname, true, Tango::Util::instance()->_UseDb);
	map<std::string,Tango::DevDouble>::iterator ite;
	if ((ite=dynScalarDoubleRO_data.find(attname))!=dynScalarDoubleRO_data.end())
	{
		/*----- PROTECTED REGION ID(BacnetConf::remove_dynScalarDoubleRO_dynamic_attribute) ENABLED START -----*/
		/* clang-format on */
		//	Add your own code
		/* clang-format off */
		/*----- PROTECTED REGION END -----*/	//	BacnetConf::remove_dynScalarDoubleRO_dynamic_attribute
		dynScalarDoubleRO_data.erase(ite);
	}
}
//--------------------------------------------------------
/**
 *	Add a dynScalarUInt32RO dynamic attribute.
 *
 *  parameter attname: attribute name to be created and added.
 */
//--------------------------------------------------------
void BacnetConf::add_dynScalarUInt32RO_dynamic_attribute(std::string attname)
{
	//	Attribute : dynScalarUInt32RO
	dynScalarUInt32ROAttrib	*dynscalaruint32ro = new dynScalarUInt32ROAttrib(attname);
	Tango::UserDefaultAttrProp	dynscalaruint32ro_prop;
	//	description	not set for dynScalarUInt32RO
	//	label	not set for dynScalarUInt32RO
	//	unit	not set for dynScalarUInt32RO
	//	standard_unit	not set for dynScalarUInt32RO
	//	display_unit	not set for dynScalarUInt32RO
	//	format	not set for dynScalarUInt32RO
	//	max_value	not set for dynScalarUInt32RO
	//	min_value	not set for dynScalarUInt32RO
	//	max_alarm	not set for dynScalarUInt32RO
	//	min_alarm	not set for dynScalarUInt32RO
	//	max_warning	not set for dynScalarUInt32RO
	//	min_warning	not set for dynScalarUInt32RO
	//	delta_t	not set for dynScalarUInt32RO
	//	delta_val	not set for dynScalarUInt32RO
	/*----- PROTECTED REGION ID(BacnetConf::att_dynScalarUInt32RO_dynamic_attribute) ENABLED START -----*/
	/* clang-format on */
	//	Add your own code
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	BacnetConf::att_dynScalarUInt32RO_dynamic_attribute
	dynscalaruint32ro->set_default_properties(dynscalaruint32ro_prop);
	//	Not Polled
	dynscalaruint32ro->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	dynScalarUInt32RO_data.insert(make_pair(attname, 0));
	add_attribute(dynscalaruint32ro);
}
//--------------------------------------------------------
/**
 *	remove a dynScalarUInt32RO dynamic attribute.
 *
 *  parameter attname: attribute name to be removed.
 */
//--------------------------------------------------------
void BacnetConf::remove_dynScalarUInt32RO_dynamic_attribute(std::string attname)
{
	remove_attribute(attname, true, Tango::Util::instance()->_UseDb);
	map<std::string,Tango::DevULong>::iterator ite;
	if ((ite=dynScalarUInt32RO_data.find(attname))!=dynScalarUInt32RO_data.end())
	{
		/*----- PROTECTED REGION ID(BacnetConf::remove_dynScalarUInt32RO_dynamic_attribute) ENABLED START -----*/
		/* clang-format on */
		//	Add your own code
		/* clang-format off */
		/*----- PROTECTED REGION END -----*/	//	BacnetConf::remove_dynScalarUInt32RO_dynamic_attribute
		dynScalarUInt32RO_data.erase(ite);
	}
}


//============================================================
//	Tool methods to get pointer on attribute data buffer
//============================================================
//--------------------------------------------------------
/**
 *	Return a pointer on dynScalarFloatRO data.
 *
 *  parameter attname: the specified attribute name.
 */
//--------------------------------------------------------
Tango::DevFloat *BacnetConf::get_dynScalarFloatRO_data_ptr(std::string &name)
{
	map<std::string,Tango::DevFloat>::iterator ite;
	if ((ite=dynScalarFloatRO_data.find(name))==dynScalarFloatRO_data.end())
	{
		TangoSys_OMemStream	tms;
		tms << "Dynamic attribute " << name << " has not been created";
		Tango::Except::throw_exception(
					(const char *)"ATTRIBUTE_NOT_FOUND",
					tms.str().c_str(),
					(const char *)"BacnetConf::get_dynScalarFloatRO_data_ptr()");
	}
	return  &(ite->second);
}
//--------------------------------------------------------
/**
 *	Return a pointer on dynScalarInt16RO data.
 *
 *  parameter attname: the specified attribute name.
 */
//--------------------------------------------------------
Tango::DevShort *BacnetConf::get_dynScalarInt16RO_data_ptr(std::string &name)
{
	map<std::string,Tango::DevShort>::iterator ite;
	if ((ite=dynScalarInt16RO_data.find(name))==dynScalarInt16RO_data.end())
	{
		TangoSys_OMemStream	tms;
		tms << "Dynamic attribute " << name << " has not been created";
		Tango::Except::throw_exception(
					(const char *)"ATTRIBUTE_NOT_FOUND",
					tms.str().c_str(),
					(const char *)"BacnetConf::get_dynScalarInt16RO_data_ptr()");
	}
	return  &(ite->second);
}
//--------------------------------------------------------
/**
 *	Return a pointer on dynScalarInt32RO data.
 *
 *  parameter attname: the specified attribute name.
 */
//--------------------------------------------------------
Tango::DevLong *BacnetConf::get_dynScalarInt32RO_data_ptr(std::string &name)
{
	map<std::string,Tango::DevLong>::iterator ite;
	if ((ite=dynScalarInt32RO_data.find(name))==dynScalarInt32RO_data.end())
	{
		TangoSys_OMemStream	tms;
		tms << "Dynamic attribute " << name << " has not been created";
		Tango::Except::throw_exception(
					(const char *)"ATTRIBUTE_NOT_FOUND",
					tms.str().c_str(),
					(const char *)"BacnetConf::get_dynScalarInt32RO_data_ptr()");
	}
	return  &(ite->second);
}
//--------------------------------------------------------
/**
 *	Return a pointer on dynScalarByteRO data.
 *
 *  parameter attname: the specified attribute name.
 */
//--------------------------------------------------------
Tango::DevUChar *BacnetConf::get_dynScalarByteRO_data_ptr(std::string &name)
{
	map<std::string,Tango::DevUChar>::iterator ite;
	if ((ite=dynScalarByteRO_data.find(name))==dynScalarByteRO_data.end())
	{
		TangoSys_OMemStream	tms;
		tms << "Dynamic attribute " << name << " has not been created";
		Tango::Except::throw_exception(
					(const char *)"ATTRIBUTE_NOT_FOUND",
					tms.str().c_str(),
					(const char *)"BacnetConf::get_dynScalarByteRO_data_ptr()");
	}
	return  &(ite->second);
}
//--------------------------------------------------------
/**
 *	Return a pointer on dynScalarBoolRO data.
 *
 *  parameter attname: the specified attribute name.
 */
//--------------------------------------------------------
Tango::DevBoolean *BacnetConf::get_dynScalarBoolRO_data_ptr(std::string &name)
{
	map<std::string,Tango::DevBoolean>::iterator ite;
	if ((ite=dynScalarBoolRO_data.find(name))==dynScalarBoolRO_data.end())
	{
		TangoSys_OMemStream	tms;
		tms << "Dynamic attribute " << name << " has not been created";
		Tango::Except::throw_exception(
					(const char *)"ATTRIBUTE_NOT_FOUND",
					tms.str().c_str(),
					(const char *)"BacnetConf::get_dynScalarBoolRO_data_ptr()");
	}
	return  &(ite->second);
}
//--------------------------------------------------------
/**
 *	Return a pointer on dynScalarDoubleRO data.
 *
 *  parameter attname: the specified attribute name.
 */
//--------------------------------------------------------
Tango::DevDouble *BacnetConf::get_dynScalarDoubleRO_data_ptr(std::string &name)
{
	map<std::string,Tango::DevDouble>::iterator ite;
	if ((ite=dynScalarDoubleRO_data.find(name))==dynScalarDoubleRO_data.end())
	{
		TangoSys_OMemStream	tms;
		tms << "Dynamic attribute " << name << " has not been created";
		Tango::Except::throw_exception(
					(const char *)"ATTRIBUTE_NOT_FOUND",
					tms.str().c_str(),
					(const char *)"BacnetConf::get_dynScalarDoubleRO_data_ptr()");
	}
	return  &(ite->second);
}
//--------------------------------------------------------
/**
 *	Return a pointer on dynScalarUInt32RO data.
 *
 *  parameter attname: the specified attribute name.
 */
//--------------------------------------------------------
Tango::DevULong *BacnetConf::get_dynScalarUInt32RO_data_ptr(std::string &name)
{
	map<std::string,Tango::DevULong>::iterator ite;
	if ((ite=dynScalarUInt32RO_data.find(name))==dynScalarUInt32RO_data.end())
	{
		TangoSys_OMemStream	tms;
		tms << "Dynamic attribute " << name << " has not been created";
		Tango::Except::throw_exception(
					(const char *)"ATTRIBUTE_NOT_FOUND",
					tms.str().c_str(),
					(const char *)"BacnetConf::get_dynScalarUInt32RO_data_ptr()");
	}
	return  &(ite->second);
}


//=============================================================
//	Add/Remove dynamic command methods
//=============================================================


} //	namespace
