//
// file :         readthread.h
//
// description :  reading thread
//
//
//
// copyleft :   Sincrotrone Trieste S.C.p.A.
//              Strada Statale 14 - km 163,5 in AREA Science Park
//              34012 Basovizza, Trieste ITALY
//


#ifndef ReadThread_H
#define ReadThread_H

#include <omnithread.h>
#include <tango.h>
#include <inttypes.h>
#include "bacnet/rpm.h" //for BACNET_READ_ACCESS_DATA
#include "bacnet/apdu.h" //forBACNET_CONFIRMED_SERVICE_ACK_DATA
//#include "bacnet/bacdef.h" //for BACNET_ADDRESS
//#include "bacnet/apdu.h" //for BACNET_CONFIRMED_SERVICE_ACK_DATA

namespace BacnetConf_ns
{

//from apps/epics/main.c
/* any valid RP or RPM data returned is put here */
/* Now using one structure for both RP and RPM data:
 * typedef struct BACnet_RP_Service_Data_t {
 *   bool new_data;
 *   BACNET_CONFIRMED_SERVICE_ACK_DATA service_data;
 *   BACNET_READ_PROPERTY_DATA data;
 *   } BACNET_RP_SERVICE_DATA;
 * static BACNET_RP_SERVICE_DATA Read_Property_Data;
 */

typedef struct BACnet_RPM_Service_Data_t {
    bool new_data;
    BACNET_CONFIRMED_SERVICE_ACK_DATA service_data;
    BACNET_READ_ACCESS_DATA *rpm_data;
} BACNET_RPM_SERVICE_DATA;
//BACNET_RPM_SERVICE_DATA Read_Property_Multiple_Data;

struct read_data_t
{
	bool found;
	bool processed;
	timeval last_read;
	uint8_t Request_Invoke_ID;
	BACNET_ADDRESS Target_Address;
	BACNET_READ_ACCESS_DATA *Read_Access_Data;
	BACNET_RPM_SERVICE_DATA Read_Property_Multiple_Data;
	bool Error_Detected;
	std::string error_desc;
};
typedef std::map<uint32_t,vector<read_data_t> > read_data_map_t;

class readthread : public omni_thread, public Tango::TangoMonitor, public Tango::LogAdapter
{	
	private:
		Tango::DeviceImpl* device;
		void abort_sleep(double time);
		void Init_Service_Handlers();
		//BACNET_READ_ACCESS_DATA *Read_Access_Data;
		//read_data_map_t read_access_data_map;
		void cleanup(void);
		//void MyRejectHandler(BACNET_ADDRESS *src, uint8_t invoke_id, uint8_t reject_reason);
		//void MyReadPropertyMultipleAckHandler(uint8_t *service_request,uint16_t service_len,BACNET_ADDRESS *src,BACNET_CONFIRMED_SERVICE_ACK_DATA *service_data);

				
	public:
		readthread(Tango::DeviceImpl* devImpl);
		~readthread();
		
		bool abortflag;
		bool waitflag;
					
	protected:
		void run(void *);
		
};	/* end class readthread() */

}

#endif

/* EOF */
